(function ($) {

    function createSingleFilterPickers(ctx) {

        var restPath = "/rest/gadget/1.0/pickers/filters";

        $(".raven-default-filter-picker", ctx).each(function () {
            var $this = $(this);
            if ($this.data("aui-ss")) return;
            var data = {showAvatar: true},
                inputText = $this.data('inputValue');

            var field = new AJS.SingleSelect({
                element: $this,
                submitInputVal: true,
                //revertOnInvalid: true,
                showDropdownButton: !!$this.data('show-dropdown-button'),
                errorMessage: AJS.I18n.getText("filters.picker.invalid.filter", "'{0}'"),
                ajaxOptions: {
                    url: contextPath + restPath,
                    query: true, // keep going back to the sever for each keystroke
                    data: data,
                    formatResponse: function (data) {
                        var savedFilters = [];
                        if (data.filters) {
                            $.each($(data.filters), function(index, filter) {
                                savedFilters[index] = new AJS.ItemDescriptor({
                                    value: filter.id,
                                    label: filter.name
                                });
                            });
                        }
                        return savedFilters;
                    }
                },
                inputText: inputText
            });

            $this.data('field-support-obj', field);
        });
    }

    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function (e, context, reason) {
        if (reason !== JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            createSingleFilterPickers(context);
        }
    });

})(AJS.$);



