(function($) {

    function init() {
        $('.raven-select-import').each(function(){
            var id = this.id;
            initialize(id);
        })
    }

    function initialize(id) {
        $('#'+id).change(function(){
            var fieldName = id.replace("_select","");
            changeSelectTextArea(fieldName);
        });
        $('#'+id).each(function(){
            var fieldName = id.replace("_select","");
            changeSelectTextArea(fieldName);
        });
        new AJS.SingleSelect({
            element: $("#"+id),
            revertOnInvalid: true
        });
    }

    $(function(){
        if($('#field-mapping-table')[0] != null){
            $("#nextButton").attr("disabled", true);
        }
    });

    var summary_count = new Array();
    var tcid_count = new Array();
    var step_count = new Array();

    function decrementFieldCounter(fieldName){
        for(var i=0; i < summary_count.length; i++){
            if (summary_count[i] == fieldName){
                summary_count.splice(i,1);
            }
        }
        for(var i=0; i < tcid_count.length; i++){
            if (tcid_count[i] == fieldName){
                tcid_count.splice(i,1);
            }
        }
        for(var i=0; i < step_count.length; i++){
            if (step_count[i] == fieldName){
                step_count.splice(i,1);
            }
        }
    }
    function incrementFieldCounter(selectedField, fieldName){
        var selectList = document.getElementById(fieldName + "_select");
        var textBox = document.getElementById(fieldName);
        var checkbox = document.getElementById(fieldName + "_checkbox");
        textBox.style.display = 'none';
        textBox.value = selectList.value;
        checkbox.disabled = true;
        switch(selectedField) {
            case "summary":
                summary_count.push(fieldName);
                checkbox.disabled = false;
                break;
            case "Test Case Identifier":
                tcid_count.push(fieldName);
                break;
            case "Step":
                step_count.push(fieldName);
                break;
            case "Data":
                break;
            case "Expected Result":
                break;
            case "DONT_MAP_IT":
                break;
            default:
                textBox.style.display = 'none';
                textBox.value = selectList.value;
                checkbox.disabled = false;
                break;
        }
    }

    function nextButtonAvailability() {
        if(summary_count.length>0 && tcid_count.length>0 && step_count.length>0){
            $("#nextButton").attr("disabled", false);
            $("#summary_warning").hide();
        }else{
            $("#nextButton").attr("disabled", true);
            $("#summary_warning").show();
        }
    }

    function changeSelectTextArea(fieldName) {
        var selectList = document.getElementById(fieldName + "_select");
        decrementFieldCounter(fieldName);
        incrementFieldCounter(selectList.value, fieldName);
        nextButtonAvailability();

    };

    $(document).ready(function(){
        init();
    });
})(AJS.$);

