var RAVEN = window.RAVEN || {};
RAVEN.Component = RAVEN.Component || {};
RAVEN.Component.TestStepsTable = (function($) {
	
	var __$ = function(elem) {
		return getContext().find(elem);
	}
	
	function getContext() {
		var $context = $('#create-issue-dialog:visible, #edit-issue-dialog:visible, #create-test-issue-dialog:visible, #create-requirement-test-issue-dialog:visible, #create-issue-dialog.jira-dialog-open, #prefillable-create-issue-dialog.jira-dialog-open');

		if ($context.length > 0) {
			return $($context);
		} else {
			return $('#page');
		}
	}
	
	this.slideToSection = function () {
		var el = __$('#manual-test-steps-form');
	    el.scrollIntoView(true);
	}
	
	var saveEditChanges = function(callback, args) {
		clearMessage();
		if (!$.trim(__$('#manual-test-steps-content td textarea.edit-content:first').val())) {
			message(AJS.I18n.getText('manual-test-steps-custom-field.invalidstep'));
		} else {
            var $row = __$('#manual-test-steps-content tr.editing');
            var rawValues = $row.find('td textarea.edit-content').map(function() {
                return $(this).val();
            }).toArray();

            var editCommands = __$('.edit-commands');
            editCommands.hide();

            var $table = __$('#manual-test-steps-table');
            $table.addClass('working');
            __$('#manual-test-steps-content td textarea.edit-content').each(function() {
                $(this).attr("disabled", "disabled");
            });

            renderWikiContent(rawValues, function(renderedValues) {
                __$('#manual-test-steps-content td textarea.edit-content').each(function(i) {
                    var view = $(this).parent().find('span.view-content');
                    view.data('raw', $(this).val());
                    view.html(renderedValues[i]).show();
                    $(this).remove();
                });

                // register changes
                saveValue();

                // replace commands
                editCommands.siblings('.view-commands').show();
                editCommands.remove();

                $row.removeClass('editing');

                if (callback && (typeof callback == 'function')) {
                    callback(args);
                }
            },
            function() {
                message(AJS.I18n.getText('manual-test-steps-custom-field.render.error'), "error");
            },
            function() {
                __$('#manual-test-steps-content td textarea.edit-content').each(function() {
                    $(this).removeAttr("disabled");
                });
                $table.removeClass('working');
            });
        }
	}

    var addStep = function() {
        clearMessage();

        if (!$.trim(__$("#step-textarea").val())) {
            message(AJS.I18n.getText('manual-test-steps-custom-field.invalidstep'), "error");
        } else {
            var rawValues = [
                __$('#step-textarea').val(),
                __$('#data-textarea').val(),
                __$('#result-textarea').val()
            ];

            __$('#add-step').attr("disabled", "disabled");
            var $table = __$('#manual-test-steps-table');
            $table.addClass('working');

            renderWikiContent(rawValues, function(renderedValues) {
                var attachmentsColumn = '';
                if (__$('#manual-test-steps-new-operation').attr('value') === 'false') {
                    attachmentsColumn = '<td></td>';
                }
                __$('#manual-test-steps-content').append('<tr></tr>');
                
                var row = __$('#manual-test-steps-content > tr:last').append('<td><span class="draghandle"></span></td>')
                .append('<td><span>' + __$('#manual-test-steps-content > tr').size() + '</span></td>')
                .append('<td class="invisible"><span></span></td>')
                .append('<td><span class="view-content"></span></td>')
                .append('<td><span class="view-content"></span></td>')
                .append('<td><span class="view-content"></span></td>')
                .append(attachmentsColumn)
                .append('<td class="operations-column"><div class="view-commands">\
                        <span title="Edit" class="icon icon-inline-edit edit-command"></span>\
                        <span title="Delete" class="icon icon-delete remove-command"></span>\
                        </div></td>');

                row.find('td .view-content').each(function(i) {
                    $(this).data('raw', rawValues[i]);
                    $(this).html(renderedValues[i]);
                });

                __$('#manual-test-steps-form textarea').val('');

                // register changes
                saveValue();
            },
            function() {
                message(AJS.I18n.getText('manual-test-steps-custom-field.render.error'), "error");
            },function() {
                __$('#add-step').removeAttr("disabled");
                $table.removeClass('working');
            });
        }
    }

	var enterEditStepMode = function($el) {
		clearMessage();
		var $row = __$('#manual-test-steps-content tr.editing');
        if ($row.size() > 0) {
            var editingStep = $row.find('td textarea.edit-content:first');
			if (!$.trim(editingStep.val())) {
				var stepId = $row.children('td:nth-child(2)').children('span:first').text(); 
				cancelEditChanges();
				message(AJS.I18n.getText('manual-test-steps-custom-field.invalidstep.reverted', stepId), "warning");
			} else {
				saveEditChanges(editStep, $el);
			}
		} else {
            editStep($el);
        }
	}

    var editStep = function($el) {
        var $row = $el.closest('tr');
        $row.addClass('editing');

        // replace spans by textareas
        $row.find("td span.view-content").each(function() {
            $(this).parent().append($('<textarea class="edit-content" rows="5"></textarea>').val($(this).data('raw')));
            $(this).hide();
        });

        // replace commands
        var viewCommands = $el.parent();
        viewCommands.hide();
        var editCommands = $('<div class="edit-commands"></div>');
        editCommands.append('<input id="update-edit-step" class="aui-button update-command" type="button" accesskey="u" value="Update">')
        .append('<a href="#" id="cancel-edit-step" class="aui-link-button cancel-command">'+AJS.I18n.getText('common.action.cancel')+'</a>');
        viewCommands.parent().append(editCommands);
    }

	var cancelEditChanges = function() {
		clearMessage();

        var $row = __$('#manual-test-steps-content tr.editing');

		$row.find('td textarea.edit-content').each(function() {
			$(this).parent().find('span.view-content').show();
			$(this).remove(); 
		});

        $row.removeClass('editing');

		// replace commands
		var editCommands = __$('.edit-commands');
		editCommands.siblings('.view-commands').show();
		editCommands.remove();
	}

	var saveValue = function() {
		var steps = __$("#manual-test-steps-content > tr").map(function() {
			return {
				"index" : parseInt($(this).children('td:nth-child(2)').children('span:first').text(), 10),
				"id" : parseInt($(this).children('td:nth-child(3)').children('span:first').text(), 10),
				"step" : $(this).children('td:nth-child(4)').children('span.view-content').data('raw'),
				"data" : $(this).children('td:nth-child(5)').children('span.view-content').data('raw'),
				"result" : $(this).children('td:nth-child(6)').children('span.view-content').data('raw')
			};
		}).get();

		__$("#manual-test-steps-value").attr('value', escapeRightLeftQuotationMarks(JSON.stringify(steps)));
		this.slideToSection();
		
	}

    function escapeRightLeftQuotationMarks(value) {
        if (value) {
            return value.replace(/“/g, '\\“').replace(/”/g, '\\”');
        } else {
            return value; 
        }
    }
	
	this.message = function(title, type) {
		clearMessage();
		if (type === 'warning') {
			AJS.messages.warning(__$('#raven-manual-test-steps-message-bar'), {
				title: title
			});
		} else {
			AJS.messages.error(__$('#raven-manual-test-steps-message-bar'), {
				title: title
			});
		}
	}
	
	this.clearMessage = function() {
		__$('#raven-manual-test-steps-message-bar').empty();
	}
	
	this.reset = function() {
		__$("#manual-test-steps-value").attr('value', '');
		__$('#manual-test-steps-content').empty();
		clearMessage();
	}

    var renderWikiContent = function(rawValues, onSuccess, onFail, onComplete) {
        $.ajax({
            type: "POST",
            url: AJS.contextPath() + '/rest/raven/1.0/text/wiki', 
            data: JSON.stringify(rawValues), 
            contentType: "application/json",
            success: onSuccess,
            fail: onFail,
            complete: onComplete
        });
    }
	
	function initView() {
		AJS.messages.setup();
		//this method will refresh manual test step value with manual test step content
		//This is useful to clean value when the "create another is checked" in create dialog
		saveValue();

		getContext().off('click.manual-step-edit');
		
		__$("#manual-test-steps-content").sortable({
			items:'tr',
			handle:'.draghandle',
            placeholder: "drag-placeholder",
			helper: function(e, tr) {
				var $originals = tr.children();
				var $helper = tr.clone();
				$helper.children().each(function(index) {
					// Set helper cell sizes to match the original sizes
					$(this).width($originals.eq(index).width())
				});
				return $helper;
			},
            start: function (event, ui) {
                ui.placeholder.html('<td colspan="8">&nbsp;</td>');
                ui.placeholder.height(ui.item.height() + 15);
            },
			update: function (event, ui) {
				__$('#manual-test-steps-content > tr').each(function(index) {
					$(this).children('td:nth-child(2)').children('span:first').text(index + 1);        
				});

				// register changes
				saveValue();
			}
		});

		__$('#add-step').off('click.raven.add-steps').on('click.raven.add-steps', addStep);

		getContext().on('click.manual-step-edit', '#manual-test-steps-content span.remove-command', function(e) {
			clearMessage();
			var el = $(this).closest('tr');
			var count = el.prevAll().length + 1;
			el.nextAll('tr').each(function( index ) {
				$(this).children('td:nth-child(2)').children('span:first').text(count + index);
			});

			el.remove();
			
			// register changes
			saveValue();
		});

		getContext().on('click.manual-step-edit', '#manual-test-steps-content span.edit-command', function() {
            enterEditStepMode($(this));
		});

		getContext().on('click.manual-step-edit', '#update-edit-step', function(e) {
			saveEditChanges();
		});

		getContext().on('click.manual-step-edit', '#cancel-edit-step', function(e) {
			cancelEditChanges();
		});
	}

	// register for NEW_CONTENT_ADDED
	JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
		if (context.find('#manual-test-steps').length > 0) {
			initView();
		}
	});
	
	return this;
})(AJS.$);
