(function ($) {

	window.RAVEN = window.RAVEN || {};
	
	RAVEN.Dialogs = RAVEN.Dialogs || {};
	
	RAVEN.Dialogs.pickStatusesDialog = function (labels, testPlanKey, allStatuses, submit) {
			var self = this; 
			
			var createPickStatusesDialog = new JIRA.FormDialog({
				id: 'raven-testPlan-pickStatuses-dialog',
				width: 560,
				height: "250px",
				stacked: true,
				content: function (render) {
					var content = RAVEN.Dialogs.pickStatus({
						dialogMode: true,
						title: labels.title,
						statuses: allStatuses
						});
					var $dialogWrapper = $(content);
					render($dialogWrapper);
				},
				submitHandler: function (e) {
		    		e.preventDefault();
		    		var pickedStatuses = getPickedStatuses();
		    		createPickStatusesDialog.hide();
					submit(pickedStatuses);
				},
				autoClose : true
			});
			
			createPickStatusesDialog.show();
			
	};
	
	RAVEN.Dialogs.pickStatusesDialog.prototype = Object.create(RAVEN.Dialogs.pickStatusesDialog.prototype);
	
	function getPickedStatuses() {
		var statuses = [];
		$(".dialogStatusPicker.selected").each(function(i,e){
			statuses.push($(e).attr("data-status"));
		});
		return statuses;
	};
	
	$(document).on("click",".selectStatus", function(e) {
		var ele = $(e.currentTarget).find("span");
		if(ele.attr("class").indexOf("selected") >= 0) {
			ele.removeClass("selected");
		} else {
			ele.addClass("selected");
		}
	});
	
	$(document).on("click",".allNoneStatus.left", function(e) {
		$(".dialogStatusPicker").each(function(i,e){
			$(e).addClass("selected");
		});
	});
	
	$(document).on("click",".allNoneStatus.right", function(e) {
		$(".dialogStatusPicker").each(function(i,e){
			$(e).removeClass("selected");
		});
	});
    
})(AJS.$);