(function($) {
	RAVEN.namespace("RAVEN.Gadget.fields");

    function message(title, message, type) {
        clearMessage();
        if (!type) {
            type = 'error';
        }
        AJS.messages[type]($('#gadget-message'), {
            title: title,
            body: message
        });
    }

	function fetchProjectComponents(gadget, project) {
		if (project) {
			$("#component").empty(); // clear options
            // append All component
            var allLabel = AJS.I18n.getText("common.label.all");
            $("#component").append('<option value="-1">'+allLabel+'</option>');

            if (project !== '__ALL__') {
                var isDisabled = $("#component").prop('disabled');
                $("#component").prop('disabled', true);

    			$.ajax({
    				type: "GET",
    	    		url: gadget.getBaseUrl() + "/rest/api/2/project/" + project + "/components",
    	    		contentType: "application/json",
    	    		success: function(data) {
    	    			if (data && data.length > 0) {
    	    				$.each(data, function(i, c) {
    	    					var selected = "";
    	    					if (gadget && gadget.getPref("component") === c.id) {
    	    						selected = " selected";
    	    					}
    	    					$("#component").append('<option value="' + c.id + '"' + selected + '>' + c.name + '</option>');
    	    				});
    	    			}
    	    		},
    				error: function(qXHR, textStatus, errorThrown) {
    					if (errorThrown && errorThrown.trim() != '') {
    						errorThrown = errorThrown + ': ' + qXHR.responseText;
    					} else {
    						errorThrown = qXHR.responseText;
    					}
    					if (gadget) {
    						message(gadget.getMsg("gadget.common.error.components"), errorThrown);
    					} else {
    						message(null, errorThrown);
    					}
    				},
    				complete: function() {
                        if (isDisabled === false) {
    					   $("#component").prop('disabled', false);
                        }
    				}
    			});
            }
		}
	}

	RAVEN.Gadget.fields.ComponentSelect = function(gadget, label, componentUserPref, disabled, selectedProject) {
		return {
			id: "component-callback-field",
        	userpref: componentUserPref,
			label: label,
			description: gadget.getMsg("gadget.common.field.component.desc"),
			type: "callbackBuilder",
			callback: function(parentDiv) {
				var $el = $("<select></select>").attr({
					"id": "component",
					"class": "select",
					"name": "component"
				});

                if (disabled === true) {
                    $el.prop('disabled', true);
                }
				parentDiv.append($el);
				var desc = gadget.getMsg("gadget.common.field.component.desc");
				parentDiv.append('<div class="description">' + desc + '</div>');

				var project = null;
				if (typeof(selectedProject) == "function") {
					project = selectedProject();
				} else if (typeof selectedProject == 'string' || selectedProject instanceof String) {
					project = selectedProject;
				}
				if (project) {
					fetchProjectComponents(gadget, project);
				}
			},
			initProjectComponents: function(gadget, project) {
				fetchProjectComponents(gadget, project);
			}
		};
	}
})(AJS.$);
