(function($) {
	RAVEN.namespace("RAVEN.Gadget.fields");

	// required by JIRA calendar resource
	if (!String.prototype.escapejQuerySelector) {
		String.prototype.escapejQuerySelector = function () {
    		return this.replace(/([:.])/g, "\\$1");
		};
	}

	RAVEN.Gadget.fields.DatePicker = function(gadget, userpref, label, description, defaultValue) {
		var fieldId = userpref;
		var fieldtriggerId = userpref + "-input-date-trigger";

		return {
			id: userpref + "-callback-field",
        	userpref: userpref,
			label: label,
			description: description,
			type: "callbackBuilder",
			callback: function(parentDiv) {
				var $el = $("<input></input>").attr({
					"id": fieldId,
					"class": "text medium-field datepicker-input",
					"name": fieldId,
					"value": defaultValue,
					"readonly": "true"
				});

				parentDiv.append($el);

				var $trigger = $('<span></span>').attr({
					"id": fieldtriggerId,
					"class": "aui-icon icon-range"
				});
				parentDiv.append($trigger);

				parentDiv.append('<div class="description">' + description + '</div>');

				// init calendar
				Calendar.setup({
					firstDay : 1,
					inputField : fieldId,
					button : fieldtriggerId,
					singleClick : true,
					showsTime : false,
					useISO8601WeekNumbers : false,
					ifFormat : '%Y-%m-%d'
				});
			}
		};
	}
})(AJS.$);