(function($) {

	var testRunView = null;

	function onNewContentAdded(e, context, reason) {
		if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#raven-test-testruns');
            if ($section.length > 0) {
                if (!$section.attr('data-initialized') && RAVEN.Utils.isCurrentIssueValid($('#raven-test-testruns-issue-key').val())) {
                    initialize();
                }
            } else if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad) {
                destroy();
            }
        }
	}

	function initialize() {
		destroy();

		testRunView = new RAVEN.Test.TestRunsView();

		$('#raven-test-testruns').attr("data-initialized", "true");
	}

    function destroy() {
        if (testRunView) {
            testRunView.destroy();
            testRunView = null;
        }
    }

	// register for NEW_CONTENT_ADDED
	JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
	JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

	$(document).ready(function() {
		$(document).on(RAVEN.Test.TestRunsView.REFRESH_VIEW, '#raven-test-testruns', function(e) {
			initialize();
		});
	});

})(AJS.$);
