/**
 * 
 */
(function($) {

    var projectView = null;
    var selectedReportKey = null;
    var report = null;

    function onNewContentAdded(e, context, reason) {

        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#report-wrapper');
            if ($section.length > 0 && !$section.attr('data-initialized')) {
                initialize();
            }
        }
    }

    //XRAY-269 Block header of Test execution page
    var initialWidth = '100%';
    var initialHeight = null;

    function fixDiv() {
        if ($('.header-filter').attr('data-initialized') === "false") {
            initialHeight = $('.header-filter').offset().top;
            $('.header-filter').attr('data-initialized', true);
        } else {
            var $headerToFix = $('.header-filter');
            var $enableHowToRead = $('#enable-how-to-read-msg');
            if ($(window).scrollTop() > initialHeight) {
                if (initialWidth === null) {
                    initialWidth = $headerToFix.width();
                }
                $headerToFix.css({
                    'position': 'fixed',
                    'top': '0px',
                    'z-index': '99',
                    'width': initialWidth,
                    'padding-bottom': '12px',
                    'background-color': '#FFF',
                    'border': '#cccccc 1px solid',
                    'margin': '7px'
                });
                $enableHowToRead.hide();
            } else {
                $headerToFix.css({
                    'position': 'relative',
                    'top': 'auto',
                    'border': 'none',
                    'width': 'auto',
                    'z-index': '0'
                });
                initialWidth = $headerToFix.width();
                if ($('#raven-notifications-icon').css('display') !== 'none') {
                    $enableHowToRead.show();
                }
            }
        }
    }


    $(window).scroll(fixDiv);
    fixDiv();

    function initialize() {

        //$('.aui-inline-dialog-contents').remove();

        //set xray report as selected in sidebar
        $(".aui-nav-selected").removeClass("aui-nav-selected");
        $('a[data-link-id="com.xpandit.plugins.xray:raven.sidebar.reports"]').parent().addClass('aui-nav-selected')

        switchReport();

        $('#report-wrapper').attr("data-initialized", "true");
        $('#raven-requirement-coverage-parameters').attr("data-initialized", "true");
    }

    function switchReport() {
        var $section = $('#report-wrapper');
        $section.empty();

        var $htmlReport = "";
        var requiresExperimentalDialog2 = $('#requiresExperimentalDialog2-val').val() == "true";
        if (!selectedReportKey) {
            selectedReportKey = $("#selected-report-key").val();
        }

        if (report) {
            report.destroy();
            report = null;
        }

        _restartHeaderButtons();

        if (selectedReportKey && selectedReportKey == "xray-report-overall-requirement-coverage-chart") {
            report = new RAVEN.Report.OverallRequirementCoverageChartReportView();
            report.render(requiresExperimentalDialog2);
        } else if (selectedReportKey && selectedReportKey == "xray-report-historical-requirement-coverage-chart") {
            report = new RAVEN.Report.HistoricalRequirementCoverageChartReportView();
            report.render(requiresExperimentalDialog2);
        } else if (selectedReportKey && selectedReportKey == "xray-report-traceability-matrix") {
            report = new RAVEN.Report.TraceabilityReportView();
            report.render(requiresExperimentalDialog2);
        } else if (selectedReportKey && selectedReportKey == "xray-report-testplan") {
            report = new RAVEN.Report.TestPlanReportView();
            report.render(requiresExperimentalDialog2);
            $("#raven-export-report-button-wrapper").show();
        } else if (selectedReportKey && selectedReportKey == "xray-report-testexecution") {
            report = new RAVEN.Report.TestExecutionReportView();
            $("#raven-export-report-button-wrapper").show();
            report.render(requiresExperimentalDialog2);
        } else if (selectedReportKey && selectedReportKey == "xray-report-testruns") {
            report = new RAVEN.Report.TestRunsReportView();
            $("#raven-export-report-button-wrapper").show();
            report.render(requiresExperimentalDialog2);
        }

    }

    function _restartHeaderButtons() {
        //Hide export button
        $("#raven-export-report-button-wrapper").hide();
    }

    /**
     *  Report Overall Requirement Coverage Chart
     */
    $(document).on('click.nav.overall.raven', '#raven-overall-requirement-coverage-report-opt', function(e) {
        $('#raven-overall-requirement-coverage-report-opt').addClass('hidden');
        $('#raven-overall-requirement-coverage-report-opt a').addClass('disabled').attr('aria-disabled', 'true');

        $('#raven-historical-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-historical-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-traceability-report-opt').removeClass('hidden');
        $('#raven-traceability-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-report-testplan-opt').removeClass('hidden');
        $('#raven-report-testplan-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-testexecution-report-opt').removeClass('hidden');
        $('#raven-testexecution-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-run-report-opt').removeClass('hidden');
        $('#raven-run-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        selectedReportKey = "xray-report-overall-requirement-coverage-chart";

        $('#raven-report-type').html(AJS.I18n.getText('overall-requirement-coverage-chart-report.label'));

        initialize();

        return false;
    });

    /**
     *  Report Historical Requirement Coverage Chart
     */
    $(document).on('click.nav.overall.raven', '#raven-historical-requirement-coverage-report-opt', function(e) {
        $('#raven-overall-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-overall-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-historical-requirement-coverage-report-opt').addClass('hidden');
        $('#raven-historical-requirement-coverage-report-opt a').addClass('disabled').attr('aria-disabled', 'true');

        $('#raven-traceability-report-opt').removeClass('hidden');
        $('#raven-traceability-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-report-testplan-opt').removeClass('hidden');
        $('#raven-report-testplan-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-testexecution-report-opt').removeClass('hidden');
        $('#raven-testexecution-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-run-report-opt').removeClass('hidden');
        $('#raven-run-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        selectedReportKey = "xray-report-historical-requirement-coverage-chart";

        $('#raven-report-type').html(AJS.I18n.getText('historical-requirement-coverage-chart-report.label'));

        initialize();

        return false;
    });

    /**
     *  Report traceability
     */
    $(document).on('click.nav.overall.raven', '#raven-traceability-report-opt', function(e) {
        $('#raven-overall-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-overall-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-historical-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-historical-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-traceability-report-opt').addClass('hidden');
        $('#raven-traceability-report-opt a').addClass('disabled').attr('aria-disabled', 'true');

        $('#raven-report-testplan-opt').removeClass('hidden');
        $('#raven-report-testplan-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-testexecution-report-opt').removeClass('hidden');
        $('#raven-testexecution-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-run-report-opt').removeClass('hidden');
        $('#raven-run-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        selectedReportKey = "xray-report-traceability-matrix";

        $('#raven-report-type').html(AJS.I18n.getText('traceability-report.label'));

        initialize();

        return false;
    });

    /** 
     *  Report Test Plan
     */
    $(document).on('click.nav.historic.raven', '#raven-report-testplan-opt', function(e) {
        $('#raven-overall-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-overall-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-historical-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-historical-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-traceability-report-opt').removeClass('hidden');
        $('#raven-traceability-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-report-testplan-opt').addClass('hidden');
        $('#raven-report-testplan-opt a').addClass('disabled').attr('aria-disabled', 'true');

        $('#raven-run-report-opt').removeClass('hidden');
        $('#raven-run-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-testexecution-report-opt').removeClass('hidden');
        $('#raven-testexecution-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        selectedReportKey = "xray-report-testplan";

        $('#raven-report-type').html(AJS.I18n.getText('testplan-report.label'));

        initialize();

        return false;
    });

    /** 
     *  Report Test Execution
     */
    $(document).on('click.nav.historic.raven', '#raven-testexecution-report-opt', function(e) {
        $('#raven-overall-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-overall-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-historical-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-historical-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-traceability-report-opt').removeClass('hidden');
        $('#raven-traceability-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-report-testplan-opt').removeClass('hidden');
        $('#raven-report-testplan-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-run-report-opt').removeClass('hidden');
        $('#raven-run-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-testexecution-report-opt').addClass('hidden');
        $('#raven-testexecution-report-opt a').addClass('disabled').attr('aria-disabled', 'true');

        selectedReportKey = "xray-report-testexecution";

        $('#raven-report-type').html(AJS.I18n.getText('testexecution-report.label'));

        initialize();

        return false;
    });

    /**
     *  Report Test Runs
     */
    $(document).on('click.nav.historic.raven', "#raven-run-report-opt", function(e){

        $('#raven-overall-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-overall-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-historical-requirement-coverage-report-opt').removeClass('hidden');
        $('#raven-historical-requirement-coverage-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-traceability-report-opt').removeClass('hidden');
        $('#raven-traceability-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-report-testplan-opt').removeClass('hidden');
        $('#raven-report-testplan-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-testexecution-report-opt').removeClass('hidden');
        $('#raven-testexecution-report-opt a').removeClass('disabled aui-dropdown2-disabled').attr('aria-disabled', 'false');

        $('#raven-run-report-opt').addClass('hidden');
        $('#raven-run-report-opt a').addClass('disabled').attr('aria-disabled', 'true');

        selectedReportKey = "xray-report-testruns";

        $('#raven-report-type').html(AJS.I18n.getText('testruns-report.label'));

        initialize();

        return false;
    });

    // register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

})(AJS.$);